Subject: Re: bug#38529: Make --pure the default for `guix environment'?

From: Taylan Kammer <[email-masked]>
Date: Wed, 4 Nov 2020 10:43:06 +0100

On 10.12.2019 18:16, Ludovic Courtès wrote:
> Hello!
> 
> "Thompson, David" <[email-masked]> skribis:
> 
>> I have long thought that --ad-hoc should be implied, as that is the
>> mode I use 99% of the time, but I disagree that --pure should be the
>> default.
> 
> I very much agree with that.  I don’t think ‘--pure’ should be the
> default, because there are valid use cases for that.
> 
> As for ‘--ad-hoc’: making it the default is technically easy.  The
> difficulty is to come up with a nice transition/deprecation mechanism so
> that we don’t break everyone’s script overnight.
> 
> Ideas on how to achieve it are welcome!
> 
> Thanks,
> Ludo’.
> 

I suppose the straightforward way of doing such a transition would be:

- In the next release, add --inputs-of and make the use of 'guix 
environment' with neither switch emit a warning saying you should use 
the new switch to explicitly enable it because the default will change.

- Later, change the default behavior and deprecate --ad-hoc as it 
becomes a no-op.

- (Optional) In some future release, remove --ad-hoc.

Taylan